﻿using System.Collections.ObjectModel;
using System.Windows.Data;
using System.Windows.Input;
using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Windows;
using Syncfusion.Windows.Shared;

namespace WPF
{
    public partial class MainWindow
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class ViewModel
    {
        private readonly Random _rnd = new Random();

        public ChartSeriesCollection Series { get; set; }

        public ICommand BuildPieCommand
        {
            get { return new DelegateCommand<object>(DoSomething); }
        }

        private void DoSomething(object instance)
        {
            BuildPie();
        }

        public ViewModel()
        {
            Series = new ChartSeriesCollection();   
           
        }

        private void BuildPie()
        {
            Series.Clear();
            var n = _rnd.Next(2, 5);
            for (int i = 1; i <= n; i++)
            {
                var series = new PieSeries
                {
                    ItemsSource = BuilModel(),
                    XBindingPath = "Country",
                    YBindingPath = "Count",
                    Label = "series " + i
                };
                Series.Add(series);
                series.Loaded += series_Loaded;
            }
        }


        void series_Loaded(object sender, RoutedEventArgs e)
        {
            Changed(sender);
        }

        public void Changed(object sender)
        {
            var z = sender as PieSeries;
            if (z.Area == null) return;
            if (z.Area.Series == null) return;
            if (z.Area.Series.Count == 0) return;
            if (z.Area.Series[0] is PieSeries == false) return;
            if (z.Area.Series == null) return;
            if (z.Area.Series.Count == 0) return;

            var points = z.Area.Series[0].ItemsSource as List<Model>;
            if (points == null) return;

            var legendItems = new ObservableCollection<LegendItem>();

            for (int i = 0; i < points.Count; i++)
            {
                var item = new LegendItem { Series = z.Area.Series[0], Item = points[i], Label = points[i].Country };
                legendItems.Add(item);

                var binding = new Binding { Source = z.Area.Series[0], Path = new PropertyPath("Interior"), Converter = new InteriorConverter(z.Area.Series[0]), ConverterParameter = i };
                BindingOperations.SetBinding(item, LegendItem.InteriorProperty, binding);
            } 
            var chartLegend = z.Area.Legend as ChartLegend;
            if (chartLegend != null) chartLegend.ItemsSource = legendItems;
        }

        public List<Model> BuilModel()
        {
            var modelValues = new List<Model>
                    {
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel(),
                        RamdomModel() 
                    };
            return modelValues;
        }

        private Model RamdomModel()
        {
            var model = new Model {Count = _rnd.Next(50, 300)};
            switch (_rnd.Next(1, 5))
            {
                case 1:
                    model.Country = "Canada";
                    break;
                 case 2:
                    model.Country = "Argentina";
                    break;
                 case 3:
                    model.Country = "USA";
                    break;
                 case 4:
                    model.Country = "Japan";
                    break;
                 case 5:
                    model.Country = "China";
                    break;
            }

            return model;
        }
    }
    

    public class Model
    {
        public string Country { get; set; }
        public int Count { get; set; }
    }
}
